%{
# include <stdio.h>
# include <stdlib.h>

# include "def.h"

extern union Node * globalptr;

extern void mark(union Node *);

extern int line_num;

union Node * make_node(int);

%}

%union {
  int nvalue;
  int svalue;
  union Node * node;
};

%token<nvalue> TNAME 
%token<svalue> TSYMBOL

%type<node> global rule_list rule lhs rhs_list rhs name_list name 

%start global

%%

global: rule_list
        {
          globalptr = $1;
        }
       ;

rule_list: rule
            {
	      $$ = make_node(RULELIST);
	      $$->rulelist.rule = $1;
	      $$->rulelist.list = NULL;
	    }    
           |rule_list rule
            {
	     union Node * ptr;
	     union Node * endptr;
	     
	     ptr = make_node(RULELIST);
	     ptr->rulelist.rule = $2;
	     ptr->rulelist.list = NULL;

	     endptr=$1;
	     while (endptr->rulelist.list!=NULL)
	       endptr=endptr->rulelist.list;
	     endptr->rulelist.list=ptr;
	     
	     $$ = $1;
	    }
           ;


rule: lhs ':' rhs_list ';'
       {
	 $$ = make_node(RULE);

	 $$->rule.id = line_num;
	 $$->rule.lhs = $1;
	 $$->rule.rhslist = $3;

	 mark($$);
       }
      ;

lhs: TNAME
      {
	/* in fact, here writing is not good, the rule not obeyed */

        $$ = make_node(NAME);
	$$->name.nvalue = $1;
      }
     ;

rhs_list: rhs
           {
	     $$ = make_node(RHSLIST);
	     $$->rhslist.rhs = $1;
	     $$->rhslist.list = NULL;
           }
          |rhs_list '|' rhs 
           {
	     union Node * ptr;
	     union Node * endptr;
	     
	     ptr = make_node(RHSLIST);
	     ptr->rhslist.rhs = $3;
	     ptr->rhslist.list = NULL;

	     endptr=$1;
	     while (endptr->rhslist.list!=NULL)
	       endptr=endptr->rhslist.list;
	     endptr->rhslist.list=ptr;
	     
	     $$ = $1;
           }
          ;

rhs:
      {
       $$ = make_node(RHS);
       $$->rhs.namelist = NULL;
      }
     |name_list
      {
        $$ = make_node(RHS);
        $$->rhs.namelist = $1;
      }
     ;

name_list: name
            {
              $$ = make_node(NAMELIST);
              $$->namelist.name = $1;
              $$->namelist.list = NULL;
            }
           |name_list name
            {
              union Node * ptr;
              union Node * endptr;

              ptr = make_node(NAMELIST);
              ptr->namelist.name = $2;
              ptr->namelist.list = NULL;

              endptr=$1;
              while (endptr->namelist.list!=NULL)
                endptr=endptr->namelist.list;
              endptr->namelist.list=ptr;

              $$ = $1;
            }
           ;
 
name: TNAME
       {
         $$ = make_node(NAME);
         $$->name.nvalue = $1;
       }
      |TSYMBOL
       {
         $$ = make_node(SYMBOL);
         $$->name.svalue = $1;
       }
      ;

%%

union Node * make_node(int var)
{
  union Node * node;
  node=(union Node *)malloc(sizeof(union Node));
  /* some how to initialize the block? */
  node->com.var = var;
  return(node);
}

yyerror()
{
  fprintf(stderr, "parser error an line %d\n", line_num);
}
